function Init()
    indicator:name("Spread");
    indicator:description("Shows spread");
    indicator:requiredSource(core.Tick);
    indicator:type(core.Indicator);
    
    indicator.parameters:addString("instrument", "Instrument", "", "EUR/USD");
    indicator.parameters:setFlag("instrument", core.FLAG_INSTRUMENTS);
end

local source = nil;

-- initializes the instance of the indicator
function Prepare(onlyName)
    source = instance.source;
    local name = instance.parameters.instrument .. " spread";
    instance:name(name);

    if onlyName then
        return ;
    end

    open = instance:addStream("open", core.Line, name .. ".open", "open", core.COLOR_UPCANDLE, 0);
end

function round(num, idp)
  local mult = 10^(idp or 0)
  return math.floor(num * mult + 0.5) / mult
end

function Update(period)
    local offer = core.host:findTable("offers"):find("Instrument", instance.parameters.instrument);
    local spread = offer.Ask - offer.Bid;
    local pip_spread = spread / offer.PointSize;
    core.host:execute("setStatus", tostring(round(pip_spread, 1)));
end
